/********************************************************
 * File name: dss.c										*
 *														*
 * Date: 2002-03-22										*
 *														*
 * Description:											*
 *														*
 ********************************************************/

#include <std.h>

#include "dss.h"
#include <pip.h>

Int     DSS_error = 0;

Int     DSS_rxCnt = 0;
Int     DSS_txCnt = 0;

#if defined (_62_)
Int     *DSS_rxPtr = NULL;
Int     *DSS_txPtr = NULL;
#else
Char    *DSS_rxPtr = NULL;
Char    *DSS_txPtr = NULL;
#endif

/*
 *  ======= DSS_txPrime ========
 */
void DSS_txPrime(void)
{
    PIP_Obj     *txPipe = &DSS_txPipe;
    static int delay = 1;       /* or 2, 3, etc. */
    static Int nested = 0;

    if (nested) {       /* prohibit recursive call via PIP_get() */
        return;
    }

    if (delay) {
        delay--;
        return;
    }

    nested = 1;

    if (DSS_txCnt == 0 && PIP_getReaderNumFrames(txPipe) > 0) {

        PIP_get(txPipe);

        DSS_txPtr = PIP_getReaderAddr(txPipe);/* must set 'Ptr' before 'Cnt' */
        DSS_txCnt = PIP_getReaderSize(txPipe);/* to synchronize with isr() */
    }

    nested = 0;
}

/*
 *  ======= DSS_rxPrime ========
 */
void DSS_rxPrime(void)
{
    PIP_Obj     *rxPipe = &DSS_rxPipe;
    static Int  nested = 0;

    if (nested) {       /* prohibit recursive call via PIP_alloc() */
        return;
    }

    nested = 1;

    if (DSS_rxCnt == 0 && PIP_getWriterNumFrames(rxPipe) > 0) {
        PIP_alloc(rxPipe);
        DSS_rxPtr = PIP_getWriterAddr(rxPipe);/* must set 'Ptr' before 'Cnt' */
        DSS_rxCnt = PIP_getWriterSize(rxPipe);/* to synchronize with isr() */
    }

    nested = 0;
}
