/************************************************************
 * File name: dss_dsk6711.c									*
 * 															*
 * Date: 2002-03-22											*
 *															*
 * Description:												*
 *															*
 ************************************************************/

#include <std.h>
#include <log.h>

#include <c6x.h>
#include "c6211dsk.h"

#define MCSP_RXINT_BIT 0x0800      /* define McBSP interrupt */

extern far LOG_Obj trace;          /* application printf() log */ 

/* function prototypes ... */
Void mcbsp1_init(void);
Uns mcbsp1_read(void);
Void mcbsp1_write(Uns out_data);

/*
 * ======== DSS_init ========
 */
Void DSS_init(void)
{   

    mcbsp1_init();

   /* Enable McBSP interrupt */
    IER |= MCSP_RXINT_BIT;
}

/*
 * ======== mcbsp0_init ========
 */ 
Void mcbsp1_init(void)
{
    /* setup SP control register */ 
    *(volatile Uns *)McBSP1_SPCR = 0x00010001;
}

/*
 * ======== mcbsp1_write ========
 */
Void mcbsp1_write(Uns out_data)
{
    volatile Uns temp;

    temp = *(volatile Uns *)McBSP1_SPCR & 0x20000;
    while (temp == 0) {
        temp = *(volatile Uns *)McBSP1_SPCR & 0x20000;
    }

    *(volatile Uns *)McBSP1_DXR = out_data;
}

/*
 * ======== mcbsp1_read ========
 */
Uns mcbsp1_read(void)
{
    volatile Uns temp;

    temp = *(volatile Uns *)McBSP1_SPCR & 0x2;
    while (temp == 0) {
        temp = *(volatile Uns *)McBSP1_SPCR & 0x2;
    }

    temp = *(volatile Uns *)McBSP1_DRR;

    return (temp);
}
